function []=eval_2_class (scores, class); 
% function []=eval_2_class (scores, class); 
% 
% evaluation of a 2-class classifier 
% scores - col. vector with scores, if positive, 1 is detected, if negative, 2
% class - col. vector with reference classes - 1 or 2. 

decisions = zeros(size(scores)); 
decisions (find(scores > 0)) = 1; 
decisions (find(scores <= 0)) = 2;
N = length(scores); 
correct = sum((decisions == class)); 
error12 = sum(((decisions == 1) & (class == 2))); 
error21 = sum(((decisions == 2) & (class == 1))); 
error= error12 + error21; 
acc = correct / N; 
errrate = error / N; 
disp(['N=' num2str(N) ', correct=' num2str(correct) ', error12=' num2str(error12) ', error21=' num2str(error21)]); 
disp(['accuracy=' num2str(acc*100) '%, err.rate=' num2str(errrate*100) '%']); 
